;---------------------------------------------------------------------
;
; Current dir handling for the HOME thing
;
; v.1.00  2005 Oct 23	initial release version
;
; copyright (c) W. Lenerz 2005
;
;---------------------------------------------------------------------
;
; The current dir is the only thing inthe HOME thing datastructure that is
; not permanent - it may change as the job sees fit.
;
;--------------------------------------------------------------------

	section util

	include dev8_keys_err
	include dev8_keys_chp
	include dev8_keys_qdos_sms
	include dev1_asm_home_data
	include dev8_keys_jcb

	xdef	setcur			; set current dir for a job with job ID
	xref	sms_ckid
	xref	h_fndjb
  

hms.reg reg	d1/d2/d3/d7/a1/a3/a4

; litle subroutine to go to current dir in a job entry
; a0 cr 	job entry start/current dir start
; d1   s

del_it2 bsr.s	del_it			; do it twice
	nop				; stupid 68K
del_it	moveq	#2,d1			; length word
	add.w	(a0),d1 		; + length
	addq.l	#1,d1
	bclr	#0,d1			; make even
	add.l	d1,a0			; point to next entry
	sub.l	d1,d0			; minus length of this name
	rts

;---------------------------------------------------------------------
; This sets the current drectory to any kind of directory.
; First we check in list entry whether it will still fit in the current space:
; If yes, just replace old current dir.
; If not, set "length" of this dir to -1, then get new mem, set current dir
; in it and set pointer to it in list entry
;---------------------------------------------------------------------


; A1 c p points to parameter list (job ID, LW, dir name)
;
setcur
	movem.l hms.reg,-(sp)
	moveq	#0,d0
	trap	#1			; get sys info
	move.l	a0,a4			; A4 points to sysvar base
	move.l	(a1),d1 		; job ID into D1
	bsr	sms_ckid		; check job ID, convert if -1
	tst.l	d0			; found?
	bne.s	cs_out			; no!
	bsr	h_fndjb 		; try to find this job in my list
	bne.s	cs_out			; ooops, not found, can't set curent dir, then!
	move.l	-chp.len(a0),d0 	; length of this common heap space
	sub.l	#chp.len,d0		; minus common heap space header
	sub.l	#hl_data,d0		; minus my list entry header
	lea	hl_data(a0),a0
	bsr.s	del_it2 		; point past first name
	sub.l	a3,a3			; preset: curr dir is in my list entry
	move.w	(a0),d1 		; length of current dir
	bge.s	c_dir			; is normal, curr dir is in list entry
	move.l	a0,a3			; keep this pointer
	move.l	2(a0),a0		; in fact, A0 points to mem space only for curr dir
	move.l	-chp.len(a0),d0 	; length
	sub.l	#chp.len,d0		; total length for string
	bra.s	c_com
c_dir	sub.l	d1,d0			; total space for total string
c_com	subq.l	#2,d0			; total space minus length word
	clr.l	d1
	move.l	set_nam(a1),a1		; point to name
	move.w	(a1)+,d1		; length of name to set
	sub.l	d1,d0
	blt.s	new_spce		; new name doesn't fit in space available
cpy_nm
; a0 points to length word for new space
; d1 = length
; A1 = new name (after length word
	move.w	d1,(a0)+		; set length word
	bra.s	cpy_lp1 		; and copy name
cpy_lp	move.b	(a1)+,(a0)+
cpy_lp1 dbf	d1,cpy_lp
	moveq	#0,d0
cs_out
	movem.l (sp)+,hms.reg
	tst.l d0
	rts
; we need a new space for the current dir, the space we have is too small
new_spce
	move.l	a0,a4			; point to length word for current dir
	move.l	a1,-(sp)
	move.l	a3,d0			; were we still in list entry ?
	beq.s	no_remv 		; yes, no need to get rid of independent mem space
	move.l	a3,a4			; this is pointer in list entry
	moveq	#sms.rchp,d0
	trap	#1			; remove old heap space
no_remv
	clr.w	(a4)			; in case I can't get new mem: no more current dir
	moveq	#sms.achp,d0		; get new mem for current dir
	move.l	d1,d7			; keep
	moveq	#-1,d2			; for myself
	trap	#1			; get new mem now
	move.l	(sp)+,a1
	tst.l	d0			; OK?
	bne.s	cs_out			; ...  no
	move.w	#-1,(a4)+		; flag new heap space
	move.l	a0,(a4) 		; set pointer to it
	move.l	d7,d1
	bra.s	cpy_nm

	end
