;---------------------------------------------------------------------
;
; find a job in my linked list for HOME thing
;
; v. 0.00	2005 Oct 23	initial release version
;
; copyright (c) 2005 W. Lenerz
;
;---------------------------------------------------------------------


	section util

	xdef	h_fndjb

	include dev8_keys_err
	include dev8_keys_chp
	include dev1_asm_home_data

;---------------------------------------------------------------------
; try to find our job in the list
;	A0 cr u pointer to first link/pointer to link if found
;	A2 c  p pointer to thing header
;	D0    r on exit error
;	D1 c  p job ID of job to be found
;
; returns	Z if if found in list, D0 undetermined
;		NZ (D0 = err.itnf) if not found in list
;
;---------------------------------------------------------------------

h_fndjb
	lea	hmt_frst(a2),a0 	; point to first
h_srch
	move.l	hl_next(a0),d0		; try to point to first/next link
	beq.s	h_nf			; there is none, job not found
	move.l	d0,a0			; point to this next one
	cmp.l	chp_ownr-chp.len(a0),d1 ; same ID ?
	bne.s	h_srch			;  ... no, try again
	clr.l	d0			; no error
	rts

h_nf	moveq	#err.itnf,d0
	rts
	end
